﻿using System;
using System.Net;
using System.Net.Http;
using System.Threading.Tasks;

class Program
{
    private static readonly HttpClient _client;

    static Program()
    {
        _client = new HttpClient()
        {
            // DefaultRequestVersion = HttpVersion.Version20,
            // DefaultVersionPolicy = HttpVersionPolicy.RequestVersionExact,
        };
    }

    static async Task Main(string[] args)
    {
        {
            HttpRequestMessage hrm = new HttpRequestMessage(HttpMethod.Get, "http://nghttp2.org/")
            {
                VersionPolicy = HttpVersionPolicy.RequestVersionOrLower,
                Version = HttpVersion.Version11,
            };

            using var response = await _client.SendAsync(hrm);
            Console.WriteLine(response.Version);
        }

        {
            HttpRequestMessage hrm = new HttpRequestMessage(HttpMethod.Get, "https://nghttp2.org/")
            {
                VersionPolicy = HttpVersionPolicy.RequestVersionOrLower,
                Version = HttpVersion.Version11,
            };

            using var response = await _client.SendAsync(hrm);
            Console.WriteLine(response.Version);
        }
    }
}
